import peasy.*;
import controlP5.*;
import java.util.*;

PeasyCam cam;
ControlP5 cp5;

int yearsI = 0;
String[] yearsList = {"1946-47", "1947-48", "1948-49","1949-50","1950-51","1951-52","1952-53","1953-54", "1954-55", "1955-56","1956-57", "1957-58", "1958-59", "1959-60", "1960-61", "1961-62", "1962-63", "1963-64", "1964-65", "1965-66", "1966-67", "1967-68", "1968-69", "1969-70", "1970-71", "1971-72", "1972-73", "1973-74", "1974-75", "1975-76", "1976-77", "1977-78", "1978-79", "1979-80", "1980-81", "1981-82", "1982-83", "1983-84", "1984-85", "1985-86", "1986-87", "1987-88", "1988-89", "1989-90", "1990-91", "1991-92", "1992-93", "1993-94", "1994-95", "1995-96", "1996-97", "1997-98", "1998-99", "1999-00", "2000-01", "2001-02", "2002-03", "2003-04", "2004-05", "2005-06", "2006-07", "2007-08", "2008-09", "2009-10", "2010-11", "2011-12", "2012-13", "2013-14", "2014-15", "2015-16", "2016-17", "2017-18", "2018-19", "2019-20", "2020-21", "2021-22", "2022-23", "2023-24"};
int startYear = 1946;
int endYear = 2024;
int totalYear = endYear-startYear;
ArrayList<Player> players = new ArrayList<Player>();
HashMap<String, HashMap<String, Player>> seasons = new HashMap<String, HashMap<String, Player>>();
Table table;
int numRows;
int X = 1600;
int Y = 1200;
int maxPts = 55;
int maxRebs = 30;
int maxAsts = 15;
float adjustX = 5;
float adjustY = 5;
float adjustZ = 5;

void setup() {
  size(1600,1200,P3D);
  colorMode(RGB);
  
  cp5 = new ControlP5(this);
  
  cam = new PeasyCam(this, X/8, Y/8, 0, 1000);
  cam.setMaximumDistance(700);
  cam.rotateX(-0.8);
  cam.rotateY(-0.5); 
  
  PFont font = createFont("Arial", 20);
  textFont(font);
  textSize(14);
  
  table = loadTable("nba_data_with_avg_and_name.csv", "header");
  numRows = table.getRowCount();
  for (int i=0; i<numRows; i++){
    //HashMap<String, Player> players_dict = new HashMap<String, Player>();
    String year =  table.getString(i,2);
    String id = table.getString(i,1);
    String name = table.getString(i,37);
    float pt = table.getFloat(i,23);
    float reb = table.getFloat(i,24);
    float ast = table.getFloat(i,25);
    Player playertemp = new Player(pt, reb, ast, id, name);
    //players_dict[id] = playertemp;
    HashMap<String, Player> currSeason = seasons.get(year);
    if (currSeason == null){
      currSeason = new HashMap<String, Player>();
    }
    currSeason.put(id, playertemp);
    seasons.put(year, currSeason);
    
  }
  //setGui();
  //for(String key : seasons.keySet()){
  //  println(key, seasons.get(key));
  //}
  //print(yearsList.getClass().getSimpleName());
}

void draw(){
  background(0);
  drawPlayers();
  drawAxes();
  drawMouseLabels();
  setGui();
  gui();
  //pushMatrix();
  //beginShape(TRIANGLES);
  //vertex(120, 300);
  //vertex(160, 120);
  //vertex(200, 300);
  //vertex(270, 80);
  //vertex(280, 300);
  //vertex(320, 80);
  //endShape();
  //popMatrix();
}
  
void drawPlayers() {
  //replace larger for loop with keypress?
  
  //for (int i = 0; i<seasons.size(); i++){
    int numPlayers = seasons.get(yearsList[yearsI]).size();
    HashMap<String, Player> currPlayer = seasons.get(yearsList[yearsI]);
    for (int j = 0; j<numPlayers; j++){
      
      Set<String> playerIDSet = currPlayer.keySet();
      ArrayList<String> playerIDs = new ArrayList<>(playerIDSet);
      String name = currPlayer.get(playerIDs.get(j)).name;
      float x = currPlayer.get(playerIDs.get(j)).pt * 10;
      float y = currPlayer.get(playerIDs.get(j)).reb * 12;
      float z = currPlayer.get(playerIDs.get(j)).ast * 15;
      pushMatrix();
      fill(75,135,195);
      //stroke(50);
      noStroke();
      translate(x,y,z);
      //stroke(255);
      //strokeWeight(10);
      sphere(2);
      //point(x,y,z);
      //maybe have it so the direction it is larger is the stat category that has largest above mean (or closest to)
      //have color map to gradient along different axes;
      //beginShape(TRIANGLES);
      //vertex(x+5, y+5,z);
      //vertex(x-5, y+5, z);
      //vertex(x, y,z);
      ////vertex(270, 80);
      ////vertex(280, 300);
      ////vertex(320, 80);
      //endShape();
      popMatrix();

      //println(name, x,y,z);
    }
  }
//3D coordinates are the player pts reb and ast 
//do I do trace here? 
//
//}

void drawMouseLabels(){
  int numPlayers = seasons.get(yearsList[yearsI]).size();
  HashMap<String, Player> currPlayer = seasons.get(yearsList[yearsI]);
  for (int j = 0; j<numPlayers; j++){
      
      Set<String> playerIDSet = currPlayer.keySet();
      ArrayList<String> playerIDs = new ArrayList<>(playerIDSet);
      String name = currPlayer.get(playerIDs.get(j)).name;
      
      float x = currPlayer.get(playerIDs.get(j)).pt * 10;
      float y = currPlayer.get(playerIDs.get(j)).reb * 12;
      float z = currPlayer.get(playerIDs.get(j)).ast * 15;
      float pts = currPlayer.get(playerIDs.get(j)).pt;
      float rebs = currPlayer.get(playerIDs.get(j)).reb;
      float asts = currPlayer.get(playerIDs.get(j)).ast;
      float mouseObjectDistance = sq(mouseX-screenX(x,y,z)) + sq(mouseY-screenY(x,y,z));
      String label = name + "\nPoints: " + str(float(round(pts*10))/10) + "\nRebounds: " + str(float(round(rebs*10))/10) + "\nAssists: " + str(float(round(asts*10))/10);
      if(mouseObjectDistance < 35) {
        pushMatrix();
        fill(255,255,255);
        textSize(12);
        hint(DISABLE_DEPTH_TEST);
        cam.beginHUD();
        
        text(label, mouseX, mouseY);
        cam.endHUD();
        hint(ENABLE_DEPTH_TEST);
        popMatrix();
      }
      
  }
   
  
  //player name, pts, reb, ast
}

void drawAxes(){
  //process: draw ticks according to adjustX/adjustY. But scales should be same..?
    //draw X
    //x-label (points)
  int numTicksX = floor(maxPts/adjustX);
  int numTicksY = floor(maxRebs/adjustY);
  int numTicksZ = floor(maxAsts/adjustZ);
  //int numTicksY = floor(maxRebs/adjustY);
  //int numTicksZ = floor(maxAsts/adjustZ);
  for (int i = 1; i <= numTicksX; i++) {
    pushMatrix();
    translate(adjustX*i*10, 0,0);
    rotateX(-PI/2);
    fill(255);
    textAlign(CENTER);
    textSize(10);
    text(int(adjustX*i), 0, 0);
    popMatrix();
  }
  for (int i = 1; i <= numTicksY; i++) {
    pushMatrix();
    translate(0, adjustY*i*12,0);
    rotateX(-PI/2);
      fill(255);
      textAlign(CENTER);
      textSize(10);
      text(int(adjustY*i), 0, 0);
      popMatrix();
  }
  for (int i = 1; i <= numTicksZ; i++) {
    pushMatrix();
    translate(0, 0, adjustZ*i*14);
    rotateX(-PI/2);
      fill(255);
      textAlign(CENTER);
      textSize(10);
      text(int(adjustZ*i), 0, 0, 0);
      popMatrix();
  }
  pushMatrix();
  textSize(15);
  fill(255);
  translate(X/6,0, -20);
  rotateX(-PI/2);
  text("Points", 0,0, 0);
  
  popMatrix();
  pushMatrix();
  translate(-50,Y/6, 0);
  rotateX(-PI/2);
  text("Rebounds", 0, 0, 0);
  popMatrix();
  pushMatrix();
  translate(-50, -Y/10, 200);
  rotateX(-PI/2);
  text("Assists", 0, Z/6, 100);
  popMatrix();
}


void setGui(){
  PFont pfont= createFont("Arial", 16, true);
  ControlFont font = new ControlFont(pfont, 12);
  
  cp5.addTextlabel("title")
  .setText(yearsList[yearsI]+" Season")
  .setPosition(X/2, 20)
  .setFont(new ControlFont(pfont, 30))
  .setColorValue(color(255,255,255, 255));
  
  //cp5.addTextlabel("subtitle")
  //.setText("2017-2023")
  //.setPosition(X/2-100, 70)
  //.setFont(new ControlFont(pfont, 20))
  //.setColorValue(color(0,0,0,255));
  
  cp5.setAutoDraw(false);
  
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
